@use "../sable";

$perc: (
  1\/2: 50%,
  1\/3: 33.333333%,
  2\/3: 66.666667%,
  1\/4: 25%,
  2\/4: 50%,
  3\/4: 75%,
  1\/5: 20%,
  2\/5: 40%,
  3\/5: 60%,
  4\/5: 80%,
  1\/6: 16.666667%,
  2\/6: 33.333333%,
  3\/6: 50%,
  4\/6: 66.666667%,
  5\/6: 83.333333%,
  1\/10: 10%,
  2\/10: 20%,
  3\/10: 30%,
  4\/10: 40%,
  5\/10: 50%,
  6\/10: 60%,
  7\/10: 70%,
  8\/10: 80%,
  9\/10: 90%,
  1\/12: 8.333333%,
  2\/12: 16.666667%,
  3\/12: 25%,
  4\/12: 33.333333%,
  5\/12: 41.666667%,
  6\/12: 50%,
  7\/12: 58.333333%,
  8\/12: 66.666667%,
  9\/12: 75%,
  10\/12: 83.333333%,
  11\/12: 91.666667%,
);

$spac: (
  0: 0,
  0\.5: 0.125rem,
  1: 0.25rem,
  1\.5: 0.375rem,
  2: 0.5rem,
  2\.5: 0.625rem,
  3: 0.75rem,
  3\.5: 0.875rem,
  4: 1rem,
  5: 1.25rem,
  6: 1.5rem,
  7: 1.75rem,
  8: 2rem,
  9: 2.25rem,
  10: 2.5rem,
  11: 2.75rem,
  12: 3rem,
  16: 4rem,
  20: 5rem,
  24: 6rem,
  28: 7rem,
  32: 8rem,
  36: 9rem,
  40: 10rem,
  44: 11rem,
  48: 12rem,
  52: 13rem,
  56: 14rem,
  60: 15rem,
  64: 16rem,
  72: 18rem,
  80: 20rem,
  96: 24rem,
) !default;

$values: sable.fun-multiMapMerge($perc, $spac);
@each $name, $number in $values {
  .p-#{$name},
  .before\:p-#{$name}::before,
  .after\:p-#{$name}::after,
  .first\:p-#{$name} *:first-child,
  .last\:p-#{$name} *:last-child {
    @include sable.spac-padding($number);
  }
  .pt-#{$name},
  .before\:pt-#{$name}::before,
  .after\:pt-#{$name}::after,
  .first\:pt-#{$name} *:first-child,
  .last\:pt-#{$name} *:last-child {
    @include sable.spac-padding-top($number);
  }
  .pb-#{$name},
  .before\:pb-#{$name}::before,
  .after\:pb-#{$name}::after,
  .first\:pb-#{$name} *:first-child,
  .last\:pb-#{$name} *:last-child {
    @include sable.spac-padding-bottom($number);
  }
  .pr-#{$name},
  .before\:pr-#{$name}::before,
  .after\:pr-#{$name}::after,
  .first\:pr-#{$name} *:first-child,
  .last\:pr-#{$name} *:last-child {
    @include sable.spac-padding-right($number);
  }
  .pl-#{$name},
  .before\:pl-#{$name}::before,
  .after\:pl-#{$name}::after,
  .first\:pl-#{$name} *:first-child,
  .last\:pl-#{$name} *:last-child {
    @include sable.spac-padding-left($number);
  }
  .px-#{$name},
  .before\:px-#{$name}::before,
  .after\:px-#{$name}::after,
  .first\:px-#{$name} *:first-child,
  .last\:px-#{$name} *:last-child {
    @include sable.spac-padding-x($number);
  }
  .py-#{$name},
  .before\:py-#{$name}::before,
  .after\:py-#{$name}::after,
  .first\:py-#{$name} *:first-child,
  .last\:py-#{$name} *:last-child {
    @include sable.spac-padding-y($number);
  }
  .ps-#{$name},
  .before\:ps-#{$name}::before,
  .after\:ps-#{$name}::after,
  .first\:ps-#{$name} *:first-child,
  .last\:ps-#{$name} *:last-child {
    @include sable.spac-padding-inline-start($number);
  }
  .pe-#{$name},
  .before\:pe-#{$name}::before,
  .after\:pe-#{$name}::after,
  .first\:pe-#{$name} *:first-child,
  .last\:pe-#{$name} *:last-child {
    @include sable.spac-padding-inline-end($number);
  }
  
  @if $number > 0 {
    .-p-#{$name},
    .before\:-p-#{$name}::before,
    .after\:-p-#{$name}::after {
      @include sable.spac-padding(-$number);
    }
    .-pt-#{$name},
    .before\:-pt-#{$name}::before,
    .after\:-pt-#{$name}::after {
      @include sable.spac-padding-top(-$number);
    }
    .-pb-#{$name},
    .before\:-pb-#{$name}::before,
    .after\:-pb-#{$name}::after {
      @include sable.spac-padding-bottom(-$number);
    }
    .-pr-#{$name},
    .before\:-pr-#{$name}::before,
    .after\:-pr-#{$name}::after {
      @include sable.spac-padding-right(-$number);
    }
    .-pl-#{$name},
    .before\:-pl-#{$name}::before,
    .after\:-pl-#{$name}::after {
      @include sable.spac-padding-left(-$number);
    }
    .-px-#{$name},
    .before\:-px-#{$name}::before,
    .after\:-px-#{$name}::after {
      @include sable.spac-padding-x(-$number);
    }
    .-py-#{$name},
    .before\:-py-#{$name}::before,
    .after\:-py-#{$name}::after {
      @include sable.spac-padding-y(-$number);
    }
  }

  .m-#{$name},
  .before\:m-#{$name}::before,
  .after\:m-#{$name}::after,
  .first\:m-#{$name} *:first-child,
  .last\:m-#{$name} *:last-child {
    @include sable.spac-margin($number);
  }
  .mt-#{$name},
  .before\:mt-#{$name}::before,
  .after\:mt-#{$name}::after,
  .first\:mt-#{$name} *:first-child,
  .last\:mt-#{$name} *:last-child {
    @include sable.spac-margin-top($number);
  }
  .mb-#{$name},
  .before\:mb-#{$name}::before,
  .after\:mb-#{$name}::after,
  .first\:mb-#{$name} *:first-child,
  .last\:mb-#{$name} *:last-child {
    @include sable.spac-margin-bottom($number);
  }
  .mr-#{$name},
  .before\:mr-#{$name}::before,
  .after\:mr-#{$name}::after,
  .first\:mr-#{$name} *:first-child,
  .last\:mr-#{$name} *:last-child {
    @include sable.spac-margin-right($number);
  }
  .ml-#{$name},
  .before\:ml-#{$name}::before,
  .after\:ml-#{$name}::after,
  .first\:ml-#{$name} *:first-child,
  .last\:ml-#{$name} *:last-child {
    @include sable.spac-margin-left($number);
  }
  .mx-#{$name},
  .before\:mx-#{$name}::before,
  .after\:mx-#{$name}::after,
  .first\:mx-#{$name} *:first-child,
  .last\:mx-#{$name} *:last-child {
    @include sable.spac-margin-x($number);
  }
  .my-#{$name},
  .before\:my-#{$name}::before,
  .after\:my-#{$name}::after,
  .first\:my-#{$name} *:first-child,
  .last\:my-#{$name} *:last-child {
    @include sable.spac-margin-y($number);
  }
  .ms-#{$name},
  .before\:ms-#{$name}::before,
  .after\:ms-#{$name}::after,
  .first\:ms-#{$name}:first-child,
  .last\:ms-#{$name}:last-child {
    @include sable.spac-margin-inline-start($number);
  }
  .me-#{$name},
  .before\:me-#{$name}::before,
  .after\:me-#{$name}::after,
  .first\:me-#{$name} *:first-child,
  .last\:me-#{$name} *:last-child {
    @include sable.spac-margin-inline-end($number);
  }
  
  @if $number > 0 {
    .-m-#{$name},
    .before\:-m-#{$name}::before,
    .after\:-m-#{$name}::after {
      @include sable.spac-margin(-$number);
    }
    .-mt-#{$name},
    .before\:-mt-#{$name}::before,
    .after\:-mt-#{$name}::after {
      @include sable.spac-margin-top(-$number);
    }
    .-mb-#{$name},
    .before\:-mb-#{$name}::before,
    .after\:-mb-#{$name}::after {
      @include sable.spac-margin-bottom(-$number);
    }
    .-mr-#{$name},
    .before\:-mr-#{$name}::before,
    .after\:-mr-#{$name}::after {
      @include sable.spac-margin-right(-$number);
    }
    .-ml-#{$name},
    .before\:-ml-#{$name}::before,
    .after\:-ml-#{$name}::after {
      @include sable.spac-margin-left(-$number);
    }
    .-mx-#{$name},
    .before\:-mx-#{$name}::before,
    .after\:-mx-#{$name}::after {
      @include sable.spac-margin-x(-$number);
    }
    .-my-#{$name},
    .before\:-my-#{$name}::before,
    .after\:-my-#{$name}::after {
      @include sable.spac-margin-y(-$number);
    }
  }
}

.mx-auto,
.first\:mx-auto *:first-child,
.last\:mx-auto *:last-child {
  @include sable.spac-margin-x(auto);
}
.my-auto,
.first\:my-auto *:first-child,
.last\:my-auto *:last-child {
  @include sable.spac-margin-y(auto);
}
.mt-auto,
.first\:mt-auto *:first-child,
.last\:mt-auto *:last-child {
  @include sable.spac-margin-top(auto);
}
.mr-auto,
.first\:mr-auto *:first-child,
.last\:mr-auto *:last-child {
  @include sable.spac-margin-right(auto);
}
.mb-auto,
.first\:mb-auto *:first-child,
.last\:mb-auto *:last-child {
  @include sable.spac-margin-bottom(auto);
}
.ml-auto,
.first\:ml-auto *:first-child,
.last\:ml-auto *:last-child {
  @include sable.spac-margin-left(auto);
}
.ms-auto,
.first\:ms-auto *:first-child,
.last\:ms-auto *:last-child {
  @include sable.spac-margin-inline-start(auto);
}
.me-auto,
.first\:me-auto *:first-child,
.last\:me-auto *:last-child {
  @include sable.spac-margin-inline-end(auto);
}

@each $bpName, $width in sable.$fun-breakpoints {
  @media (min-width: #{$width}) {
    @each $name, $number in $values {
      .#{$bpName}\:p-#{$name},
      .#{$bpName}\:before\:p-#{$name}::before,
      .#{$bpName}\:after\:p-#{$name}::after,
      .#{$bpName}\:first\:p-#{$name} *:first-child,
      .#{$bpName}\:last\:p-#{$name} *:last-child {
        @include sable.spac-padding($number);
      }
      .#{$bpName}\:pt-#{$name},
      .#{$bpName}\:before\:pt-#{$name}::before,
      .#{$bpName}\:after\:pt-#{$name}::after,
      .#{$bpName}\:first\:pt-#{$name} *:first-child,
      .#{$bpName}\:last\:pt-#{$name} *:last-child {
        @include sable.spac-padding-top($number);
      }
      .#{$bpName}\:pb-#{$name},
      .#{$bpName}\:before\:pb-#{$name}::before,
      .#{$bpName}\:after\:pb-#{$name}::after,
      .#{$bpName}\:first\:pb-#{$name} *:first-child,
      .#{$bpName}\:last\:pb-#{$name} *:last-child {
        @include sable.spac-padding-bottom($number);
      }
      .#{$bpName}\:pr-#{$name},
      .#{$bpName}\:before\:pr-#{$name}::before,
      .#{$bpName}\:after\:pr-#{$name}::after,
      .#{$bpName}\:first\:pr-#{$name} *:first-child,
      .#{$bpName}\:last\:pr-#{$name} *:last-child {
        @include sable.spac-padding-right($number);
      }
      .#{$bpName}\:pl-#{$name},
      .#{$bpName}\:before\:pl-#{$name}::before,
      .#{$bpName}\:after\:pl-#{$name}::after,
      .#{$bpName}\:first\:pl-#{$name} *:first-child,
      .#{$bpName}\:last\:pl-#{$name} *:last-child {
        @include sable.spac-padding-left($number);
      }
      .#{$bpName}\:px-#{$name},
      .#{$bpName}\:before\:px-#{$name}::before,
      .#{$bpName}\:after\:px-#{$name}::after,
      .#{$bpName}\:first\:px-#{$name} *:first-child,
      .#{$bpName}\:last\:px-#{$name} *:last-child {
        @include sable.spac-padding-x($number);
      }
      .#{$bpName}\:py-#{$name},
      .#{$bpName}\:before\:py-#{$name}::before,
      .#{$bpName}\:after\:py-#{$name}::after,
      .#{$bpName}\:first\:py-#{$name} *:first-child,
      .#{$bpName}\:last\:py-#{$name} *:last-child {
        @include sable.spac-padding-y($number);
      }
      .#{$bpName}\:ps-#{$name},
      .#{$bpName}\:before\:ps-#{$name}::before,
      .#{$bpName}\:after\:ps-#{$name}::after,
      .#{$bpName}\:first\:ps-#{$name} *:first-child,
      .#{$bpName}\:last\:ps-#{$name} *:last-child {
        @include sable.spac-padding-inline-start($number);
      }
      .#{$bpName}\:pe-#{$name},
      .#{$bpName}\:before\:pe-#{$name}::before,
      .#{$bpName}\:after\:pe-#{$name}::after,
      .#{$bpName}\:first\:pe-#{$name} *:first-child,
      .#{$bpName}\:last\:pe-#{$name} *:last-child {
        @include sable.spac-padding-inline-end($number);
      }
      
      @if $number > 0 {
        .#{$bpName}\:-p-#{$name},
        .#{$bpName}\:before\:-p-#{$name}::before,
        .#{$bpName}\:after\:-p-#{$name}::after {
          @include sable.spac-padding(-$number);
        }
        .#{$bpName}\:-pt-#{$name},
        .#{$bpName}\:before\:-pt-#{$name}::before,
        .#{$bpName}\:after\:-pt-#{$name}::after {
          @include sable.spac-padding-top(-$number);
        }
        .#{$bpName}\:-pb-#{$name},
        .#{$bpName}\:before\:-pb-#{$name}::before,
        .#{$bpName}\:after\:-pb-#{$name}::after {
          @include sable.spac-padding-bottom(-$number);
        }
        .#{$bpName}\:-pr-#{$name},
        .#{$bpName}\:before\:-pr-#{$name}::before,
        .#{$bpName}\:after\:-pr-#{$name}::after {
          @include sable.spac-padding-right(-$number);
        }
        .#{$bpName}\:-pl-#{$name},
        .#{$bpName}\:before\:-pl-#{$name}::before,
        .#{$bpName}\:after\:-pl-#{$name}::after {
          @include sable.spac-padding-left(-$number);
        }
        .#{$bpName}\:-px-#{$name},
        .#{$bpName}\:before\:-px-#{$name}::before,
        .#{$bpName}\:after\:-px-#{$name}::after {
          @include sable.spac-padding-x(-$number);
        }
        .#{$bpName}\:-py-#{$name},
        .#{$bpName}\:before\:-py-#{$name}::before,
        .#{$bpName}\:after\:-py-#{$name}::after {
          @include sable.spac-padding-y(-$number);
        }
      }
      
      .#{$bpName}\:m-#{$name},
      .#{$bpName}\:before\:m-#{$name}::before,
      .#{$bpName}\:after\:m-#{$name}::after,
      .#{$bpName}\:first\:m-#{$name} *:first-child,
      .#{$bpName}\:last\:m-#{$name} *:last-child {
        @include sable.spac-margin($number);
      }
      .#{$bpName}\:mt-#{$name},
      .#{$bpName}\:before\:mt-#{$name}::before,
      .#{$bpName}\:after\:mt-#{$name}::after,
      .#{$bpName}\:first\:mt-#{$name} *:first-child,
      .#{$bpName}\:last\:mt-#{$name} *:last-child {
        @include sable.spac-margin-top($number);
      }
      .#{$bpName}\:mb-#{$name},
      .#{$bpName}\:before\:mb-#{$name}::before,
      .#{$bpName}\:after\:mb-#{$name}::after,
      .#{$bpName}\:first\:mb-#{$name} *:first-child,
      .#{$bpName}\:last\:mb-#{$name} *:last-child {
        @include sable.spac-margin-bottom($number);
      }
      .#{$bpName}\:mr-#{$name},
      .#{$bpName}\:before\:mr-#{$name}::before,
      .#{$bpName}\:after\:mr-#{$name}::after,
      .#{$bpName}\:first\:mr-#{$name} *:first-child,
      .#{$bpName}\:last\:mr-#{$name} *:last-child {
        @include sable.spac-margin-right($number);
      }
      .#{$bpName}\:ml-#{$name},
      .#{$bpName}\:before\:ml-#{$name}::before,
      .#{$bpName}\:after\:ml-#{$name}::after,
      .#{$bpName}\:first\:ml-#{$name} *:first-child,
      .#{$bpName}\:last\:ml-#{$name} *:last-child {
        @include sable.spac-margin-left($number);
      }
      .#{$bpName}\:mx-#{$name},
      .#{$bpName}\:before\:mx-#{$name}::before,
      .#{$bpName}\:after\:mx-#{$name}::after,
      .#{$bpName}\:first\:mx-#{$name} *:first-child,
      .#{$bpName}\:last\:mx-#{$name} *:last-child {
        @include sable.spac-margin-x($number);
      }
      .#{$bpName}\:my-#{$name},
      .#{$bpName}\:before\:my-#{$name}::before,
      .#{$bpName}\:after\:my-#{$name}::after,
      .#{$bpName}\:first\:my-#{$name} *:first-child,
      .#{$bpName}\:last\:my-#{$name} *:last-child {
        @include sable.spac-margin-y($number);
      }
      .#{$bpName}\:ms-#{$name},
      .#{$bpName}\:before\:ms-#{$name}::before,
      .#{$bpName}\:after\:ms-#{$name}::after,
      .#{$bpName}\:first\:ms-#{$name} *:first-child,
      .#{$bpName}\:last\:ms-#{$name} *:last-child {
        @include sable.spac-margin-inline-start($number);
      }
      .#{$bpName}\:me-#{$name},
      .#{$bpName}\:before\:me-#{$name}::before,
      .#{$bpName}\:after\:me-#{$name}::after,
      .#{$bpName}\:first\:me-#{$name} *:first-child,
      .#{$bpName}\:last\:me-#{$name} *:last-child {
        @include sable.spac-margin-inline-end($number);
      }
      
      @if $number > 0 {
        .#{$bpName}\:-m-#{$name},
        .#{$bpName}\:before\:-m-#{$name}::before,
        .#{$bpName}\:after\:-m-#{$name}::after {
          @include sable.spac-margin(-$number);
        }
        .#{$bpName}\:-mt-#{$name},
        .#{$bpName}\:before\:-mt-#{$name}::before,
        .#{$bpName}\:after\:-mt-#{$name}::after {
          @include sable.spac-margin-top(-$number);
        }
        .#{$bpName}\:-mb-#{$name},
        .#{$bpName}\:before\:-mb-#{$name}::before,
        .#{$bpName}\:after\:-mb-#{$name}::after {
          @include sable.spac-margin-bottom(-$number);
        }
        .#{$bpName}\:-mr-#{$name},
        .#{$bpName}\:before\:-mr-#{$name}::before,
        .#{$bpName}\:after\:-mr-#{$name}::after {
          @include sable.spac-margin-right(-$number);
        }
        .#{$bpName}\:-ml-#{$name},
        .#{$bpName}\:before\:-ml-#{$name}::before,
        .#{$bpName}\:after\:-ml-#{$name}::after {
          @include sable.spac-margin-left(-$number);
        }
        .#{$bpName}\:-mx-#{$name},
        .#{$bpName}\:before\:-mx-#{$name}::before,
        .#{$bpName}\:after\:-mx-#{$name}::after {
          @include sable.spac-margin-x(-$number);
        }
        .#{$bpName}\:-my-#{$name},
        .#{$bpName}\:before\:-my-#{$name}::before,
        .#{$bpName}\:after\:-my-#{$name}::after {
          @include sable.spac-margin-y(-$number);
        }
      }
    }
    
    .#{$bpName}\:mx-auto,
    .#{$bpName}\:first\:mx-auto *:first-child,
    .#{$bpName}\:last\:mx-auto *:last-child {
      @include sable.spac-margin-x(auto);
    }
    .#{$bpName}\:my-auto,
    .#{$bpName}\:first\:my-auto *:first-child,
    .#{$bpName}\:last\:my-auto *:last-child {
      @include sable.spac-margin-y(auto);
    }
    .#{$bpName}\:mt-auto,
    .#{$bpName}\:first\:mt-auto *:first-child,
    .#{$bpName}\:last\:mt-auto *:last-child {
      @include sable.spac-margin-top(auto);
    }
    .#{$bpName}\:mr-auto,
    .#{$bpName}\:first\:mr-auto *:first-child,
    .#{$bpName}\:last\:mr-auto *:last-child {
      @include sable.spac-margin-right(auto);
    }
    .#{$bpName}\:mb-auto,
    .#{$bpName}\:first\:mb-auto *:first-child,
    .#{$bpName}\:last\:mb-auto *:last-child {
      @include sable.spac-margin-bottom(auto);
    }
    .#{$bpName}\:ml-auto,
    .#{$bpName}\:first\:ml-auto *:first-child,
    .#{$bpName}\:last\:ml-auto *:last-child {
      @include sable.spac-margin-left(auto);
    }
    .#{$bpName}\:ms-auto,
    .#{$bpName}\:first\:ms-auto *:first-child,
    .#{$bpName}\:last\:ms-auto *:last-child {
      @include sable.spac-margin-inline-start(auto);
    }
    .#{$bpName}\:me-auto,
    .#{$bpName}\:first\:me-auto *:first-child,
    .#{$bpName}\:last\:me-auto *:last-child {
      @include sable.spac-margin-inline-end(auto);
    }
  }
}
